package aprioriUtil;

import java.util.List;
import java.util.Map;
import java.util.Set;

public class FreqItemSet<I> {
    // contains the list of frequentItems where each fequent item is a set.
    private final List<Set<I>> listOfFrequentItems;
    // Map that contains the frequent
    private final Map<Set<I>, Integer> supportCountMap;
    private final double minSupport;
    private final int noOfTransactions;

    // Constructor for FreqItemSet
    public FreqItemSet(List<Set<I>> freqItemList,
            Map<Set<I>, Integer> supportCountMap,
            double minSup,
            int tranNum) {
        this.listOfFrequentItems = freqItemList;
        this.supportCountMap = supportCountMap;
        this.minSupport = minSup;
        this.noOfTransactions = tranNum;
    }

    public List<Set<I>> getFreqItemList() {
        return listOfFrequentItems;
    }

    public Map<Set<I>, Integer> getSupportCountMap() {
        return supportCountMap;
    }

    public double getSup(Set<I> itemset) {
        return 1.0 * supportCountMap.get(itemset) / noOfTransactions;
    }
}
